package compbio.data.msa;

import java.security.InvalidParameterException;
import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.naming.ldap.UnsolicitedNotificationEvent;

import compbio.data.sequence.Alignment;
import compbio.data.sequence.RNAStruct;
import compbio.metadata.JobSubmissionException;
import compbio.metadata.LimitExceededException;
import compbio.metadata.Option;
import compbio.metadata.Preset;
import compbio.metadata.ResultNotAvailableException;
import compbio.metadata.UnsupportedRuntimeException;
import compbio.metadata.WrongParameterException;

/*
 * Interface for tools that results RNA secondary structure information
 * 
 * Still Unsure whether It would be better to use just the aligned fastaList
 * or the Alignment object 
 */

// effect of a different targetNamespace?
@WebService(targetNamespace = "http://msa.data.compbio/01/01/2010/")
public interface FoldWS<T> 
		extends 
			JABAService,
			JManagement,
			Metadata<T> {

	
	// Is Alignment object JaxB compatible?
	
	String fold(
			@WebParam(name = "alignment") Alignment alignment)
			throws UnsupportedRuntimeException, LimitExceededException,
			JobSubmissionException;
	
	String customFold(
			@WebParam(name = "alignment") Alignment alignment,
			@WebParam(name = "options") List<Option<T>> options)
			throws UnsupportedRuntimeException, LimitExceededException,
			JobSubmissionException, WrongParameterException;
	
	String presetFold(
			@WebParam(name = "alignment") Alignment alignment,
			@WebParam(name = "preset") Preset<T> preset)
			throws UnsupportedRuntimeException, LimitExceededException,
			JobSubmissionException, WrongParameterException;
	
	String getResult(@WebParam(name = "jobId") String jobId)
		throws ResultNotAvailableException;
			
}
